// project created on 12.10.2001 at 15:21
using System;

abstract class AbstractBuilder 
{
		abstract public void BuildRoot();
		abstract public void BuildWall();
		abstract public void BuilFoundation();
}

class MyBulderSuperHouse : AbstractBuilder
{
		override public void BuildRoot()
		{
			Console.WriteLine("      ---    ");
			Console.WriteLine("   --------  ");
			Console.WriteLine("-------------"); 
		}
		override public void BuildWall()
		{
			for (int x=1;x<5;x++)
			Console.WriteLine("|            |");

		}
		override public void BuilFoundation()
		{
			Console.WriteLine("-------------");
			Console.WriteLine("|-----------|");
			Console.WriteLine("-------------"); 
		}
}


class MyBulderSmalHouse : AbstractBuilder
{
		override public void BuildRoot()
		{
			Console.WriteLine("   --------  ");
			Console.WriteLine("-------------"); 
		}
		override public void BuildWall()
		{
			for (int x=1;x<3;x++)
			Console.WriteLine("|            |");

		}
		override public void BuilFoundation()
		{
			
		}
}

class Creator
{
	public void Create(AbstractBuilder ab)
	{
		ab.BuildRoot();
		ab.BuildWall();
		ab.BuilFoundation();
	}
}

class MainClass
{
	public static void Main(string[] args)
	{
		Creator cr = new Creator();
		cr.Create(new MyBulderSuperHouse());
		Console.WriteLine(); 
		cr.Create(new MyBulderSmalHouse());
	}
}
